// SetupDlg.cpp : 実装ファイル
//

#include "stdafx.h"
#include "Setup.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ダイアログ データ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSetupDlg ダイアログ



CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
	, m_sel(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_SERVICE, m_sel);
}

BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CSetupDlg メッセージ ハンドラ

BOOL CSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	
	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CSetupDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CSetupDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CSetupDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSetupDlg::OnBnClickedOk()
{
	UpdateData();

	if(m_sel == 0)
	{
		if(MessageBox("セットアップを実行すると、サーバの場所を動かせなくなります。\r\nデスクトップなど一時的な場所でセットアップを実行している場合は、他の場所に移してから再実行してください。\r\nセットアップを続けますか？","サーバ位置の確認",MB_ICONINFORMATION | MB_OKCANCEL)==IDOK)
		{
			Run("/UnInstall");
			if(Run("/InstallService"))
			{
				MessageBox("セットアップに失敗しました・・・","エラー",MB_ICONSTOP | MB_OK);
				return;
			}
			MessageBox("「04WebServer Service」をサービスとして登録しました。\r\n初めに「ServerController.exe」を起動し、サーバの設定を行ってください。","セットアップ完了",MB_ICONINFORMATION | MB_OK);
		}
	}
	else if(m_sel == 1)
	{
		if(Run("/UnInstall"))
		{
			MessageBox("セットアップに失敗しました・・・","エラー",MB_ICONSTOP | MB_OK);
			return;
		}

		MessageBox("セットアップが終了しました。\r\n「ServerController.exe」を起動すると、サーバが起動できます。","セットアップ完了",MB_ICONINFORMATION | MB_OK);
	}
	else
		MessageBox("アンインストールしました。","セットアップ完了",MB_ICONINFORMATION | MB_OK);

	OnOK();
	return;
}

//	実行
int CSetupDlg::Run(CString option)
{

	CString	command = GetAppPath() + "04WebServer.exe " + option;

	STARTUPINFO StartupInfo;
	PROCESS_INFORMATION ProcessInfo;

	::ZeroMemory(&StartupInfo, sizeof(STARTUPINFO));
	StartupInfo.cb = sizeof(STARTUPINFO);
	::ZeroMemory(&ProcessInfo, sizeof(PROCESS_INFORMATION));

	int err = CreateProcess(	NULL,
								command.GetBuffer(0),
								NULL,
								NULL,
								FALSE,
								0,
								NULL,
								NULL,
								&StartupInfo,
								&ProcessInfo);

	if(err==0)
		return(-1);

	//	終了まで待つ
	WaitForSingleObject(ProcessInfo.hProcess,INFINITE);

	DWORD	ret = 0;
	::GetExitCodeProcess(ProcessInfo.hProcess,&ret);

	return(ret);
}

//	モジュールパスを取得
CString CSetupDlg::GetAppPath()
{
	char	s[MAX_PATH+1];
	DWORD len = GetModuleFileName(NULL, s, MAX_PATH);

	while ( s[len--]!='\\' && len!=0 )
		;
	s[len+2] = '\0';        // ￥マークで終わらせる

	return(s);
}


